CON
        _clkmode        =       xtal1 + pll16x
        _xinfreq        =       5_000_000
           debug        =       1


VAR
  byte bgapiTXBuffer[64]
  byte bgapiRXBuffer[64]
  byte payload [64]
OBJ     
  Comm : "FullDuplexSerial"
  BLE  : "FullDuplexSerial" 

Pub Start

    BLE.start(9,8,0,57600)


    if debug == 1
      Comm.start(31,30,0,57600)       ' Initialize Debug from Prop to PC
      repeat 3
        waitcnt(cnt + clkfreq)
      Comm.str(string("Start Demo BLE112A BGlib_Spin"))
      repeat 3
        waitcnt(cnt + clkfreq)
      Comm.str(string("Send Hello")) 
      'system_hello
      gap_set_mode(2, 2)
      'system_address_get
      repeat 3
        waitcnt(cnt + clkfreq)  

    repeat
     
     readResponse
     

PUB gap_set_mode(discover, connect) 
    payload[0] := discover
    payload[1] := connect
    return sendCommand(2, 6, 1)
PUB system_reset(boot_in_dfu) 
    payload[0] := boot_in_dfu
    return sendCommand(1, 0, 0)
PUB system_hello 
    return sendCommand(0, 0, 1)
   'Sends out the Hello command Response is 4 byte 0 0 0 1
PUB system_address_get 
    return sendCommand(0, 0, 2)
PUB system_reg_write(address, value) 
    payload[0] := address
    payload[1] := value
    return sendCommand(3, 0, 3)
PUB system_reg_read(address) 
    payload[0] := address
    return sendCommand(2, 0, 4)
PUB system_get_counters
    return sendCommand(0, 0, 5)
PUB system_get_connections
    return sendCommand(0, 0, 6)
PUB system_read_memory(address, length) 
    payload[0] := address
    payload[1] := length
    return sendCommand(5, 0, 7)
PUB system_get_info
    return sendCommand(0, 0, 8)
PUB system_endpoint_tx(endpoint,data)  | len
    len := strsize(@data)
    payload[0] := endpoint
    bytemove(@payload+1, @data, len)
    return sendCommand(2 + len, 0, 9)
PUB system_whitelist_append(address, address_type) 
    payload[0] := address
    payload[1] := address_type
    return sendCommand(7, 0, 10)
PUB system_whitelist_remove(address, address_type) 
    payload[0] := address
    payload[1] := address_type
    return sendCommand(7, 0, 11)
PUB system_whitelist_clear
    return sendCommand(0, 0, 12)
PUB system_endpoint_rx(endpoint, size) 
    payload[0] := endpoint
    payload[1] := size
    return sendCommand(2, 0, 13)
PUB system_endpoint_set_watermarks(endpoint, rx, tx) 
    payload[0] := endpoint
    payload[1] := rx
    payload[2] := tx
    return sendCommand(3, 0, 14)
PUB flash_ps_defrag 
    return sendCommand(0, 1, 0)
PUB flash_ps_dump
    return sendCommand(0, 1, 1)
PUB flash_ps_erase_all
    return sendCommand(0, 1, 2)
PUB flash_ps_save(key,value)| len      '16-a8
    len := strsize(@value)
    payload[0] := key
    payload[1] := key << 8 
    bytemove(@payload+2, @value, len)
    return sendCommand(3 + len, 1, 3)
PUB flash_ps_load(key)       'Check 16 bit  messed up 
    payload[0] := key
    payload[1] := key << 8
    return sendCommand(2, 1, 4)
PUB flash_ps_erase(key)      'Check 16 bit  messed up
    payload[0] := key
    payload[1] := key << 8
    return sendCommand(2, 1, 5)
PUB flash_erase_page(page) 
    payload[0] := page
    return sendCommand(1, 1, 6)
PUB flash_write_words(address,len, words) ' 16-8-a8  fix
    payload[0] := address
    payload[1] := address << 8 
    payload[2] := words
    return sendCommand(3 + len, 1, 7)
PUB attributes_write(handle, offset,len,value) '16-8-8-a8 fix 
    payload[0] := handle
    payload[1] := handle << 8
    payload[2] := offset
    payload[1] := value
    return sendCommand(4 + len, 2, 0)
PUB attributes_read(handle, offset)   '16-16
    payload[0] := handle
    payload[1] := handle << 8
    payload[2] := offset
    payload[3] := offset << 8
    return sendCommand(4, 2, 1)
PUB attributes_read_type(handle)  '16
    payload[0] :=  handle
    payload[1] :=  handle << 8
    return sendCommand(2, 2, 2)
PUB sendCommand(len, commandClass, commandId ) | x ,i ,j
    bgapiTXBuffer[0] := $00
    bgapiTXBuffer[1] := (len & $FF)
    bgapiTXBuffer[2] := commandClass
    bgapiTXBuffer[3] := commandId
    if len > 0
       j:= 4
       i:= 0
       repeat len
        bgapiTXBuffer[j++]  := payload[i++]
    x:=len+4
    i:=0
    repeat x 
      BLE.tx(bgapiTXBuffer[i++])
    bytefill(@bgapiTXBuffer, 0,64 )  ' clear tx buffer
    bytefill(@payload, 0, 64)         ' clear payload Buffer buffer 
    return

PUB readResponse  | x ,i  
bytefill(@bgapiRXBuffer, 0, 64)  ' clear tx buffer
x:=0
bgapiRXBuffer[x++]:= BLE.RXCHECK
if bgapiRXBuffer[0] & $78 ==  $00   ' Start found ?
    bgapiRXBuffer[x++]:= BLE.RX
    repeat 2 + bgapiRXBuffer[1]
     bgapiRXBuffer[x++]:= BLE.RX
     
    if debug == 1
      i:=0
      Comm.str(string("Start found-->")) 
      repeat 4 
       Comm.hex(bgapiRXBuffer[i++],2)
       Comm.str(string(",")) 
      Comm.str(string("payload-->"))  
      repeat  bgapiRXBuffer[1]
       Comm.hex(bgapiRXBuffer[i++],2)
       Comm.str(string(" "))
       
    if ((bgapiRXBuffer[0] & $80) == $00)'$00 = Response packet
      if debug == 1
        Comm.str(string("<---Response packet -->"))
      if bgapiRXBuffer[2] == 0
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_system_reset->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_system_hello->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_system_address_get->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_system_reg_write->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_system_reg_read->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_system_get_counters->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-rsp_system_get_connections->"))         
         if bgapiRXBuffer[3] == 7
          if debug == 1
           Comm.str(string("<-rsp_system_read_memory"))         
         if bgapiRXBuffer[3] == 8
          if debug == 1
           Comm.str(string("<-rsp_system_get_info->"))         
         if bgapiRXBuffer[3] == 9
          if debug == 1
           Comm.str(string("<-rsp_system_endpoint_tx->"))         
         if bgapiRXBuffer[3] == 10
          if debug == 1
           Comm.str(string("<-rsp_system_whitelist_append->"))         
         if bgapiRXBuffer[3] == 11
          if debug == 1
           Comm.str(string("<-rsp_system_whitelist_remove->"))         
         if bgapiRXBuffer[3] == 12
          if debug == 1
           Comm.str(string("<-rsp_system_whitelist_clear->"))         
         if bgapiRXBuffer[3] == 13
          if debug == 1
           Comm.str(string("<-rsp_system_endpoint_rx->"))         
         if bgapiRXBuffer[3] == 14
          if debug == 1
           Comm.str(string("<-rsp_system_endpoint_set_watermarks->"))
                   
      if bgapiRXBuffer[2] == 1
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_flash_ps_defrag->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_flash_ps_dump->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_flash_ps_erase_all->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_flash_ps_save->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_flash_ps_load->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_flash_ps_erase->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-rsp_flash_erase_page->"))         
         if bgapiRXBuffer[3] == 7
          if debug == 1
           Comm.str(string("<-rsp_flash_write_words"))

      if bgapiRXBuffer[2] == 2
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_attributes_write->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_attributes_read->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_attributes_read_type->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_attributes_user_read_response->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_attributes_user_write_response->"))

      if bgapiRXBuffer[2] == 3
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_connection_disconnect->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_connection_get_rssi->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_connection_update->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_connection_version_update->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_connection_channel_map_get->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_connection_channel_map_set->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-rsp_connection_features_get->"))         
         if bgapiRXBuffer[3] == 7
          if debug == 1
           Comm.str(string("<-rsp_connection_get_status"))
         if bgapiRXBuffer[3] == 8
          if debug == 1
           Comm.str(string("<-rsp_connection_raw_tx"))

      if bgapiRXBuffer[2] == 4
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_attclient_find_by_type_value->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_attclient_read_by_group_type->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_attclient_read_by_type->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_attclient_find_information->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_attclient_read_by_handle->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_attclient_attribute_write->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-rsp_attclient_write_command->"))         
         if bgapiRXBuffer[3] == 7
          if debug == 1
           Comm.str(string("<-rsp_attclient_indicate_confirm"))
         if bgapiRXBuffer[3] == 8
          if debug == 1
           Comm.str(string("<-rsp_attclient_read_long"))
         if bgapiRXBuffer[3] == 9
          if debug == 1
           Comm.str(string("<-rsp_attclient_prepare_write->"))         
         if bgapiRXBuffer[3] == 10
          if debug == 1
           Comm.str(string("<-rsp_attclient_execute_write"))
         if bgapiRXBuffer[3] == 11
          if debug == 1
           Comm.str(string("<-rsp_attclient_read_multiple"))

      if bgapiRXBuffer[2] == 5
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_sm_encrypt_start->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_sm_set_bondamode->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_sm_delete_bonding->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_sm_set_parameters->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_sm_passkey_entry->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_sm_get_bonds->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-rsp_sm_set_oob_data->"))

      if bgapiRXBuffer[2] == 6
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_gap_set_privacy_flags->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_gap_set_mode->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_gap_discover->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_gap_connect_direct->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_gap_end_procedure->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_gap_connect_selective->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-rsp_gap_set_filtering->"))         
         if bgapiRXBuffer[3] == 7
          if debug == 1
           Comm.str(string("<-rsp_gap_set_scan_parameters"))
         if bgapiRXBuffer[3] == 8
          if debug == 1
           Comm.str(string("<-rsp_gap_set_adv_parameters"))
         if bgapiRXBuffer[3] == 9
          if debug == 1
           Comm.str(string("<-rsp_gap_set_adv_data->"))         
         if bgapiRXBuffer[3] == 10
          if debug == 1
           Comm.str(string("<-rsp_gap_set_directed_connectamode"))

      if bgapiRXBuffer[2] == 7
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_hardware_io_port_config_irq->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_hardware_set_soft_timer->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_hardware_adc_read->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_hardware_io_port_config_direction->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_hardware_io_port_config_function->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_hardware_io_port_config_pull->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-rsp_hardware_io_port_write->"))         
         if bgapiRXBuffer[3] == 7
          if debug == 1
           Comm.str(string("<-rsp_hardware_io_port_read"))         
         if bgapiRXBuffer[3] == 8
          if debug == 1
           Comm.str(string("<-rsp_hardware_spi_config->"))         
         if bgapiRXBuffer[3] == 9
          if debug == 1
           Comm.str(string("<-rsp_hardware_spi_transfer->"))         
         if bgapiRXBuffer[3] == 10
          if debug == 1
           Comm.str(string("<-rsp_hardware_i2c_read->"))         
         if bgapiRXBuffer[3] == 11
          if debug == 1
           Comm.str(string("<-rsp_hardware_i2c_write->"))         
         if bgapiRXBuffer[3] == 12
          if debug == 1
           Comm.str(string("<-rsp_hardware_set_txpower->"))         
         if bgapiRXBuffer[3] == 13
          if debug == 1
           Comm.str(string("<-rsp_hardware_timer_comparator->"))       

      if bgapiRXBuffer[2] == 8
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-rsp_test_phy_tx->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-rsp_test_phy_rx->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-rsp_test_phy_end->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-rsp_test_phy_reset->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-rsp_test_get_channel_map->"))         
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-rsp_test_debug->"))

         
'----------------------------Events----------------------------          
    
    if ((bgapiRXBuffer[0] ) == $80)     '$80 = Event packet
      if debug == 1
        Comm.str(string("<---Event packet -->"))

      if bgapiRXBuffer[2] == 0
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_system_boot->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-evt_system_debug->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-evt_system_endpoint_watermark_rx->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-evt_system_endpoint_watermark_tx->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-evt_system_script_failure->"))         

      if bgapiRXBuffer[2] == 1
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_flash_ps_key->"))

      if bgapiRXBuffer[2] == 2
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_attributes_value->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-evt_attributes_user_read_request->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-evt_attributes_status->"))

      if bgapiRXBuffer[2] == 3
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_connection_status->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-evt_connection_version_ind->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-evt_connection_feature_ind->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-evt_connection_raw_rx->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-evt_connection_disconnected->"))

      if bgapiRXBuffer[2] == 4
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_attclient_indicated->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-evt_attclient_procedure_completed->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-evt_attclient_group_found->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-evt_attclient_attribute_found->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-evt_attclient_find_information_found->"))
         if bgapiRXBuffer[3] == 5
          if debug == 1
           Comm.str(string("<-evt_attclient_attribute_value->"))         
         if bgapiRXBuffer[3] == 6
          if debug == 1
           Comm.str(string("<-evt_attclient_read_multiple_response->"))

      if bgapiRXBuffer[2] == 5
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_sm_smp_data->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-evt_sm_bonding_fail->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-evt_sm_passkey_display->"))
         if bgapiRXBuffer[3] == 3
          if debug == 1
           Comm.str(string("<-evt_sm_passkey_request->"))         
         if bgapiRXBuffer[3] == 4
          if debug == 1
           Comm.str(string("<-evt_sm_bond_status->"))

      if bgapiRXBuffer[2] == 6
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_gap_scan_response->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-evt_gap_mode_changed->"))

      if bgapiRXBuffer[2] == 7
         if bgapiRXBuffer[3] == 0
          if debug == 1
           Comm.str(string("<-evt_hardware_io_port_status->"))
         if bgapiRXBuffer[3] == 1
          if debug == 1
           Comm.str(string("<-evt_hardware_soft_timer->"))         
         if bgapiRXBuffer[3] == 2
          if debug == 1
           Comm.str(string("<-evt_hardware_adc_result->"))

      if bgapiRXBuffer[2] == 8 
          if debug == 1
           Comm.str(string("<-???->"))
               
 bytefill(@bgapiTXBuffer, 0, 64)      ' clear tx buffer  
     